#include <cmath>
#include <cstdio>
#include <vector>
#include <iostream>
#include <algorithm>
#include <memory>
#include "main_helper.hpp"
#include "ui/widget.hpp"
#include "../include/my_lib.hpp"
 
using namespace std;
 
int length_of_array;
 
ostream & operator << (ostream & ost, const int a[])
{
    // bad form: using global length_of_array
    for(int i = 0; i < length_of_array; ++i) {
        ost << a[i] << " ";
    }
    return ost;
}
 
// remove all instances of element n, return new length
int remove_element(int a[], int n, int elem)
{
    int new_length = 0;
    for(int i = 0; i < n; ++i) {
        if(a[i] != elem) {
            if(i != new_length) {
                a[new_length] = a[i];
            }
            ++new_length;
        }
    }
    return new_length;
}
 
// remove all duplicates of an element, return new length
int remove_duplicates(int a[], int n)
{
    int last = 0;
    for(int i = 1; i < n; ++i) {
        if(a[last] != a[i]) {
            ++last;
            a[last] = a[i];
        }
    }
    return last + 1;
}
 
int main() {
    length_of_array = 6;
    int a[6] = { 10, 20, 20, 30, 40, 40 };
    int item_to_remove = 20;
    cout << "Removing " << item_to_remove << endl;
    length_of_array = remove_element(a, length_of_array, item_to_remove);
    cout << "a became " << a << endl;
 
    length_of_array = 6;
    int b[6] = { 10, 20, 20, 30, 40, 40 };
    length_of_array = remove_duplicates(b, length_of_array);
    cout << "Removing duplicates yielded " << length_of_array << " items " << b << endl;

	main_helper_fn();
	UI::widget_cb();
	cout << "sizeof(int) is " << sizeof(int) << "." << endl;
	my_lib_fn();
	my_lib_fn(5);

	{
		std::unique_ptr<int> up( new int() );
		if (up) {
		    cout << "unique_ptr passes if." << endl;
		} else {
		    cout << "unique_ptr fails if." << endl;
		}
		up.release();
		if (up) {
		    cout << "unique_ptr 2 passes if." << endl;
		} else {
		    cout << "unique_ptr 2 fails if." << endl;
		}
		if (up.get()) {
		    cout << "unique_ptr 3 passes if." << endl;
		} else {
		    cout << "unique_ptr 3 fails if." << endl;
		}
	}

    // This_function_is_not_defined();
 
    cout << "Done." << endl;
    return 0;
}
